//+------------------------------------------------------------------+
//|                                              s-OpenBuy+Magic.mq4 |
//+------------------------------------------------------------------+
#property copyright " valenok2003@mail.ru"
#property link      "http://bluedream.ucoz.ru"
#property show_inputs
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
extern int Magic = 1;
extern double Lot = 0.01;
extern bool 
   Alert_ON = true,
   Alert_ERR = false;
string _Comment = " ";
int start()
{  int Slip = MathRound((MarketInfo(Symbol(),MODE_ASK)-MarketInfo(Symbol(),MODE_BID))/Point);
   int Cnt = 0;
   int _Ticket = -1;
   double _Price = NormalizeDouble(Ask,Digits);
   double _SL = 0;// if(Loss != 0)  _SL = NormalizeDouble(Bid - Loss*Point,Digits);
   double _TP = 0;// if(Profit != 0)_TP = NormalizeDouble(Bid + Profit*Point,Digits);
   while(_Ticket == -1 && Cnt < 100)  {
      _Ticket = OrderSend(Symbol(),OP_BUY,Lot,_Price,Slip,0,0,_Comment + " Magic=" + Magic,Magic,0,CLR_NONE);
      _Ticket = check_open_order(OP_BUY,_Ticket, GetLastError());
      Cnt++;
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_open_order()       
//| :
//| -  
//| -   
//| -  ,   OrderSend()                             
//|      -1
//+------------------------------------------------------------------+
int check_open_order(int _Type_Order, int _Ticket, int _ERROR)
{  string _Function = "check_open_order():";
//--------
   if(_Ticket > 0)
   {  OrderSelect(_Ticket,SELECT_BY_TICKET);             
      if((OrderType() ==  OP_SELL || OrderType() ==  OP_BUY) && _ERROR == 0)
      {  output_alert(_Function+txt_order_type(_Type_Order)+" !");
      }
      else _Ticket = -1;
   }
   error(_Function + txt_order_type(_Type_Order), _ERROR);
//--------
   return(_Ticket);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_alert()  
//| :
//| -  
//+------------------------------------------------------------------+
void output_alert(string _Txt_Alert)
{  string _Function = "output_alert():";
   if(Alert_ON == true) Alert(txt_TF(Period()) + " " + _Comment + ": " + _Txt_Alert);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| txt_order_type()      
//+------------------------------------------------------------------+
string txt_order_type(int _Type_Order)
{  string _Function = "txt_order_type():",
      _Txt;
//--------
   switch(_Type_Order)
   {  case OP_BUY: _Txt = "OP_BUY";
      break;
      case OP_SELL: _Txt = "OP_SELL";
      break;
      case OP_BUYLIMIT: _Txt = "OP_BUYLIMIT";
      break;
      case OP_SELLLIMIT: _Txt = "OP_SELLLIMIT";
      break;
      case OP_BUYSTOP: _Txt = "OP_BUYSTOP";
      break;
      case OP_SELLSTOP: _Txt = "OP_SELLSTOP";
      break;
      default: 
         error(_Function, 4203);
      break;
   }  
   return(_Txt);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                14.06.2011
//+------------------------------------------------------------------+
//| txt_TF()                   
//+------------------------------------------------------------------+
string txt_TF( int _TF)
{  string _Function = "txt_TF():";
   string _Txt_TF;
   switch(_TF)
   {
     case PERIOD_M1:  _Txt_TF = "M1";  break;
     case PERIOD_M5:  _Txt_TF = "M5";  break;
     case PERIOD_M15: _Txt_TF = "M15"; break;
     case PERIOD_M30: _Txt_TF = "M30"; break;
     case PERIOD_H1:  _Txt_TF = "H1";  break;
     case PERIOD_H4:  _Txt_TF = "H4";  break;
     case PERIOD_D1:  _Txt_TF = "D1";  break;
     case PERIOD_W1:  _Txt_TF = "W1";  break;
     case PERIOD_MN1: _Txt_TF = "MN1"; break;
     default: Alert("   " + _TF); break;
   }
   return(_Txt_TF);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| error()  
//| :                  
//| -  ; 
//| -   
//| -  ;  
//+------------------------------------------------------------------+
string error(string _Function, int _Num_Error)
{  string _Txt_Error = "";
   switch(_Num_Error)
   { //----  ,   :
      case 0:   _Txt_Error = " ";                                               break;
      case 1:   _Txt_Error = " ,   ";                      break;
      case 2:   _Txt_Error = " ";                                             break;
      case 3:   _Txt_Error = " ";                                   break;
      case 4:   _Txt_Error = "  ";                                    break;
      case 5:   _Txt_Error = "   ";                      break;
      case 6:   _Txt_Error = "    ";                            break;
      case 7:   _Txt_Error = " ";                                        break;
      case 8:   _Txt_Error = "  ";                                   break;
      case 9:   _Txt_Error = "   ";             break;
      case 64:  _Txt_Error = " ";                                        break;
      case 65:  _Txt_Error = "  ";                                 break;
      case 128: _Txt_Error = "    ";                    break;
      case 129: _Txt_Error = " ";                                        break;
      case 130: _Txt_Error = " ";                                       break;
      case 131: _Txt_Error = " ";                                       break;
      case 132: _Txt_Error = " ";                                             break;
      case 133: _Txt_Error = " ";                                       break;  
      case 134: _Txt_Error = "    ";               break;
      case 135: _Txt_Error = " ";                                          break;
      case 136: _Txt_Error = " ";                                                 break;
      case 137: _Txt_Error = " ";                                             break;
      case 138: _Txt_Error = " ";                                               break;
      case 139: _Txt_Error = "    ";                  break;
      case 140: _Txt_Error = "  ";                                 break;
      case 141: _Txt_Error = "  ";                                   break;
      case 145: _Txt_Error = " ,     ";      break;
      case 146: _Txt_Error = "  ";                               break;
      case 147: _Txt_Error = "     ";   break;
      case 148: _Txt_Error = "   .";                     break;
      //----    MQL4-:
      case 4000: _Txt_Error = " ";                                              break;
      case 4001: _Txt_Error = "  ";                          break;
      case 4002: _Txt_Error = "  -  ";                          break;
      case 4003: _Txt_Error = "    ";                            break;
      case 4004: _Txt_Error = "    ";            break;
      case 4005: _Txt_Error = "      ";             break;
      case 4006: _Txt_Error = "    ";                     break;
      case 4007: _Txt_Error = "    ";                         break;
      case 4008: _Txt_Error = " ";                             break;
      case 4009: _Txt_Error = "   ";                   break;
      case 4010: _Txt_Error = "    ";                       break;
      case 4011: _Txt_Error = "  ";                                  break;
      case 4012: _Txt_Error = "    ";                              break;
      case 4013: _Txt_Error = "  ";                                         break;
      case 4014: _Txt_Error = " ";                                     break;
      case 4015: _Txt_Error = " ";                                    break;
      case 4016: _Txt_Error = " ";                             break;
      case 4017: _Txt_Error = " DLL  ";                                 break;
      case 4018: _Txt_Error = "  ";                         break;
      case 4019: _Txt_Error = "  ";                              break;
      case 4020: _Txt_Error = "     ";        break; 
      case 4021: _Txt_Error = "   ,   "; break;
      case 4022: _Txt_Error = " ";                                          break;
      case 4050: _Txt_Error = "   ";              break;
      case 4051: _Txt_Error = "   ";                 break;
      case 4052: _Txt_Error = "   ";                     break;
      case 4053: _Txt_Error = " ";                                          break;
      case 4054: _Txt_Error = "  -";            break;
      case 4055: _Txt_Error = "  ";                     break;
      case 4056: _Txt_Error = " ";                                    break;
      case 4057: _Txt_Error = "   ";                 break;
      case 4058: _Txt_Error = "   ";                     break;
      case 4059: _Txt_Error = "     ";                  break;
      case 4060: _Txt_Error = "  ";                                    break;
      case 4061: _Txt_Error = "  ";                                   break;
      case 4062: _Txt_Error = "   string";                          break;
      case 4063: _Txt_Error = "   integer";                         break;
      case 4064: _Txt_Error = "   double";                          break;
      case 4065: _Txt_Error = "    ";                   break;
      case 4066: _Txt_Error = "     ";  break;
      case 4067: _Txt_Error = "    ";                 break;
      case 4099: _Txt_Error = " ";                                             break;
      case 4100: _Txt_Error = "    ";                              break;
      case 4101: _Txt_Error = "  ";                                  break;
      case 4102: _Txt_Error = "   ";                           break;
      case 4103: _Txt_Error = "  ";                                 break;
      case 4104: _Txt_Error = "    ";                     break;
      case 4105: _Txt_Error = "    ";                                 break;
      case 4106: _Txt_Error = " ";                                      break;
      case 4107: _Txt_Error = "     ";         break;
      case 4108: _Txt_Error = "  ";                                   break;
      case 4109: _Txt_Error = "  .   .";     break;
      case 4110: _Txt_Error = "   .    .";  break;
      case 4111: _Txt_Error = "   .    ."; break;
      case 4200: _Txt_Error = "  ";                                   break;
      case 4201: _Txt_Error = "   ";                  break;
      case 4202: _Txt_Error = "  ";                                    break;
      case 4203: _Txt_Error = "  ";                                 break;
      case 4204: _Txt_Error = "  ";                                       break;
      case 4205: _Txt_Error = "  ";                                break;
      case 4206: _Txt_Error = "   ";                            break;
      case 4207: _Txt_Error = "    ";                            break;
      default:   _Txt_Error = " ";
   }
   if(_Num_Error!=0)
   {  Print(_Function+"("+_Num_Error+")"+_Txt_Error);
      if(Alert_ERR) Alert(_Comment +":"+_Function+"("+_Num_Error+")"+_Txt_Error);
   }
//----
  return(_Txt_Error);
}
//+------------------------------------------------------------------+
//+-------

